<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLContainersAggregate&lt; AlgData &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classTIGLContainersAggregate-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLContainersAggregate&lt; AlgData &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__data__structures.html">Data Structures</a> &#124; <a class="el" href="group__core.html">Core Classes</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Base class for aggregate information.  
 <a href="classTIGLContainersAggregate.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglContainersAggregate_8hpp_source.html">tiglContainersAggregate.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a04afa8cf6216839d4c877fe28e34ad53"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a04afa8cf6216839d4c877fe28e34ad53">localAggregateInit</a> (uint_fast32_t ssIndex, uint_fast32_t numLocActiveNodes)</td></tr>
<tr class="memdesc:a04afa8cf6216839d4c877fe28e34ad53"><td class="mdescLeft">&#160;</td><td class="mdescRight">Resets the aggregate parameters before the new superstep.  <a href="#a04afa8cf6216839d4c877fe28e34ad53">More...</a><br /></td></tr>
<tr class="separator:a04afa8cf6216839d4c877fe28e34ad53"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca8c7367d645f65d1d2c7fbc96eb3096"><td class="memTemplParams" colspan="2">template&lt;typename VERTEX_ITERATOR &gt; </td></tr>
<tr class="memitem:aca8c7367d645f65d1d2c7fbc96eb3096"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#aca8c7367d645f65d1d2c7fbc96eb3096">localAggregateUpdate</a> (VERTEX_ITERATOR vertexIt, uint_fast32_t currNumMessages)</td></tr>
<tr class="memdesc:aca8c7367d645f65d1d2c7fbc96eb3096"><td class="mdescLeft">&#160;</td><td class="mdescRight">Updates the aggregate information after a single node execution during a superstep.  <a href="#aca8c7367d645f65d1d2c7fbc96eb3096">More...</a><br /></td></tr>
<tr class="separator:aca8c7367d645f65d1d2c7fbc96eb3096"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0fe6f8be5e07c64170b6a92f057db61c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0fe6f8be5e07c64170b6a92f057db61c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a0fe6f8be5e07c64170b6a92f057db61c">externalAggregateUpdate</a> (<a class="el" href="classTIGLCommunicationAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a> *aggSysInfo)</td></tr>
<tr class="memdesc:a0fe6f8be5e07c64170b6a92f057db61c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Updates the aggregate information after receiving an update from other devices. <br /></td></tr>
<tr class="separator:a0fe6f8be5e07c64170b6a92f057db61c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ee8a15559012f6b8bb3df99887f4594"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a3ee8a15559012f6b8bb3df99887f4594">prepareAggregateSysMessage</a> (<a class="el" href="classTIGLCommunicationAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a> *aggSysInfo)</td></tr>
<tr class="memdesc:a3ee8a15559012f6b8bb3df99887f4594"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prepares the aggregate information system message (at the end of the superstep)  <a href="#a3ee8a15559012f6b8bb3df99887f4594">More...</a><br /></td></tr>
<tr class="separator:a3ee8a15559012f6b8bb3df99887f4594"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2b7398a983604cf319ecc14b5dc43cee"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a2b7398a983604cf319ecc14b5dc43cee">incrementExternalMessagesCount</a> (uint_fast32_t currNumMessages)</td></tr>
<tr class="memdesc:a2b7398a983604cf319ecc14b5dc43cee"><td class="mdescLeft">&#160;</td><td class="mdescRight">Increments the number of external Messages after a single node compute in a superstep.  <a href="#a2b7398a983604cf319ecc14b5dc43cee">More...</a><br /></td></tr>
<tr class="separator:a2b7398a983604cf319ecc14b5dc43cee"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9b0510a2daf3d252622f75cc3a12b10"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#af9b0510a2daf3d252622f75cc3a12b10">setNumLocalActiveNoes</a> (uint_fast32_t numActive)</td></tr>
<tr class="memdesc:af9b0510a2daf3d252622f75cc3a12b10"><td class="mdescLeft">&#160;</td><td class="mdescRight">set the number of local active nodes at the end of a superstep  <a href="#af9b0510a2daf3d252622f75cc3a12b10">More...</a><br /></td></tr>
<tr class="separator:af9b0510a2daf3d252622f75cc3a12b10"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6be61ecacbdac8f97e134141fe89a64b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6be61ecacbdac8f97e134141fe89a64b"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a6be61ecacbdac8f97e134141fe89a64b">getNumExternalMessages</a> ()</td></tr>
<tr class="memdesc:a6be61ecacbdac8f97e134141fe89a64b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of external messages in the current superstep. <br /></td></tr>
<tr class="separator:a6be61ecacbdac8f97e134141fe89a64b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a69865b656cd9b474e149625492f89b3a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a69865b656cd9b474e149625492f89b3a"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a69865b656cd9b474e149625492f89b3a">getPastNumExternalMessages</a> ()</td></tr>
<tr class="memdesc:a69865b656cd9b474e149625492f89b3a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of external messages in the previous superstep. <br /></td></tr>
<tr class="separator:a69865b656cd9b474e149625492f89b3a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8a260b73f6eca28cc04fef12c7e3edac"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8a260b73f6eca28cc04fef12c7e3edac"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a8a260b73f6eca28cc04fef12c7e3edac">getNumTotalMessages</a> ()</td></tr>
<tr class="memdesc:a8a260b73f6eca28cc04fef12c7e3edac"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the total number of output messages of the device in the current superstep. <br /></td></tr>
<tr class="separator:a8a260b73f6eca28cc04fef12c7e3edac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3913c2be0d087f69892ee0d1b4e02c08"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3913c2be0d087f69892ee0d1b4e02c08"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a3913c2be0d087f69892ee0d1b4e02c08">getPastNumTotalMessages</a> ()</td></tr>
<tr class="memdesc:a3913c2be0d087f69892ee0d1b4e02c08"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the total number of output messages of the device in the previous superstep. <br /></td></tr>
<tr class="separator:a3913c2be0d087f69892ee0d1b4e02c08"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a13da64d53762dc1e1e0900e28903c2cf"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a13da64d53762dc1e1e0900e28903c2cf"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a13da64d53762dc1e1e0900e28903c2cf">getNumVertices</a> ()</td></tr>
<tr class="memdesc:a13da64d53762dc1e1e0900e28903c2cf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the total number of vertices in the whole graph. <br /></td></tr>
<tr class="separator:a13da64d53762dc1e1e0900e28903c2cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa63f0a94c65a484525209b3b446a8280"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aa63f0a94c65a484525209b3b446a8280"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#aa63f0a94c65a484525209b3b446a8280">setNumVertices</a> (uint_fast32_t num)</td></tr>
<tr class="memdesc:aa63f0a94c65a484525209b3b446a8280"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the total number of vertices in the whole graph. <br /></td></tr>
<tr class="separator:aa63f0a94c65a484525209b3b446a8280"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a60a16ff13b899f8237994cac8b01908e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a60a16ff13b899f8237994cac8b01908e"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a60a16ff13b899f8237994cac8b01908e">getNumLocalVertices</a> ()</td></tr>
<tr class="memdesc:a60a16ff13b899f8237994cac8b01908e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of local vertices. <br /></td></tr>
<tr class="separator:a60a16ff13b899f8237994cac8b01908e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a87a3a907d1ccffd79eeb24b11ae9bfc4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a87a3a907d1ccffd79eeb24b11ae9bfc4"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a87a3a907d1ccffd79eeb24b11ae9bfc4">setNumLocalVertices</a> (uint_fast32_t num)</td></tr>
<tr class="memdesc:a87a3a907d1ccffd79eeb24b11ae9bfc4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the number of local vertices. <br /></td></tr>
<tr class="separator:a87a3a907d1ccffd79eeb24b11ae9bfc4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a12614a74824ea634b4665bf6e0b6022d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a12614a74824ea634b4665bf6e0b6022d"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a12614a74824ea634b4665bf6e0b6022d">getNumSS</a> ()</td></tr>
<tr class="memdesc:a12614a74824ea634b4665bf6e0b6022d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the superstep count. <br /></td></tr>
<tr class="separator:a12614a74824ea634b4665bf6e0b6022d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2563e0a0ac054729638cd9b55359df00"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2563e0a0ac054729638cd9b55359df00"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a2563e0a0ac054729638cd9b55359df00">getMaxActiveAlgData</a> ()</td></tr>
<tr class="memdesc:a2563e0a0ac054729638cd9b55359df00"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the maximum value of the algorithm data of all active nodes for the current superstep. <br /></td></tr>
<tr class="separator:a2563e0a0ac054729638cd9b55359df00"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4e308f42d847083bba45040eda5a9eeb"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4e308f42d847083bba45040eda5a9eeb"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a4e308f42d847083bba45040eda5a9eeb">getPastMaxActiveAlgData</a> ()</td></tr>
<tr class="memdesc:a4e308f42d847083bba45040eda5a9eeb"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the maximum value of the algorithm data of all active nodes for the previous superstep. <br /></td></tr>
<tr class="separator:a4e308f42d847083bba45040eda5a9eeb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a142af06cf094b1ae4dac2a8abfd55310"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a142af06cf094b1ae4dac2a8abfd55310"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a142af06cf094b1ae4dac2a8abfd55310">getMinActiveAlgData</a> ()</td></tr>
<tr class="memdesc:a142af06cf094b1ae4dac2a8abfd55310"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the minimum value of the algorithm data of all active nodes for the current superstep. <br /></td></tr>
<tr class="separator:a142af06cf094b1ae4dac2a8abfd55310"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a17eb0efe3b39b2ac61930fedc6cf7237"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a17eb0efe3b39b2ac61930fedc6cf7237"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a17eb0efe3b39b2ac61930fedc6cf7237">getPastMinActiveAlgData</a> ()</td></tr>
<tr class="memdesc:a17eb0efe3b39b2ac61930fedc6cf7237"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the minimum value of the algorithm data of all active nodes for the previous superstep. <br /></td></tr>
<tr class="separator:a17eb0efe3b39b2ac61930fedc6cf7237"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a43df95a92f21ee9e2e2a1443629f5cfc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a43df95a92f21ee9e2e2a1443629f5cfc"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a43df95a92f21ee9e2e2a1443629f5cfc">getSumActiveAlgData</a> ()</td></tr>
<tr class="memdesc:a43df95a92f21ee9e2e2a1443629f5cfc"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the sum of the algorithm data of all active nodes for the current superstep. <br /></td></tr>
<tr class="separator:a43df95a92f21ee9e2e2a1443629f5cfc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9c7d3314127c59ce3ed1c23378b6e57e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9c7d3314127c59ce3ed1c23378b6e57e"></a>
AlgData &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a9c7d3314127c59ce3ed1c23378b6e57e">getPastSumActiveAlgData</a> ()</td></tr>
<tr class="memdesc:a9c7d3314127c59ce3ed1c23378b6e57e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the sum of the algorithm data of all active nodes for the previous superstep. <br /></td></tr>
<tr class="separator:a9c7d3314127c59ce3ed1c23378b6e57e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a305621751cb671f32cfac297765b50bc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a305621751cb671f32cfac297765b50bc"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a305621751cb671f32cfac297765b50bc">numVertices</a></td></tr>
<tr class="memdesc:a305621751cb671f32cfac297765b50bc"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of vertices in the graph <br /></td></tr>
<tr class="separator:a305621751cb671f32cfac297765b50bc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adbea704396b2b82f8f9b260c86206e6e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adbea704396b2b82f8f9b260c86206e6e"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#adbea704396b2b82f8f9b260c86206e6e">numLocalVertices</a></td></tr>
<tr class="memdesc:adbea704396b2b82f8f9b260c86206e6e"><td class="mdescLeft">&#160;</td><td class="mdescRight">number of local vertices for this device <br /></td></tr>
<tr class="separator:adbea704396b2b82f8f9b260c86206e6e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5561ee95dd89b5f948275baf2069f383"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5561ee95dd89b5f948275baf2069f383"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a5561ee95dd89b5f948275baf2069f383">countSS</a></td></tr>
<tr class="memdesc:a5561ee95dd89b5f948275baf2069f383"><td class="mdescLeft">&#160;</td><td class="mdescRight">superstep counter <br /></td></tr>
<tr class="separator:a5561ee95dd89b5f948275baf2069f383"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acc02e42cdc6d4cf91525e563535c6ac2"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acc02e42cdc6d4cf91525e563535c6ac2"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#acc02e42cdc6d4cf91525e563535c6ac2">numTotalMessages</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:acc02e42cdc6d4cf91525e563535c6ac2"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of output messages over a superstep history <br /></td></tr>
<tr class="separator:acc02e42cdc6d4cf91525e563535c6ac2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adbc8349ec3065a2dfccebce5527bec82"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adbc8349ec3065a2dfccebce5527bec82"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#adbc8349ec3065a2dfccebce5527bec82">numExternalMessages</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:adbc8349ec3065a2dfccebce5527bec82"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of external output messages over a superstep history <br /></td></tr>
<tr class="separator:adbc8349ec3065a2dfccebce5527bec82"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a36c75840693e07da4d59fe8269720fa9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a36c75840693e07da4d59fe8269720fa9"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a36c75840693e07da4d59fe8269720fa9">numLocalActiveNodes</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:a36c75840693e07da4d59fe8269720fa9"><td class="mdescLeft">&#160;</td><td class="mdescRight">number of local active nodes over a superstep history <br /></td></tr>
<tr class="separator:a36c75840693e07da4d59fe8269720fa9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a38a14d8e84fbe0103c1c043d4485d958"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a38a14d8e84fbe0103c1c043d4485d958"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a38a14d8e84fbe0103c1c043d4485d958">numTotalActiveNodes</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:a38a14d8e84fbe0103c1c043d4485d958"><td class="mdescLeft">&#160;</td><td class="mdescRight">total number of active nodes over a superstep history <br /></td></tr>
<tr class="separator:a38a14d8e84fbe0103c1c043d4485d958"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada6c83411d9eb54ddcba58b7db52c7ca"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ada6c83411d9eb54ddcba58b7db52c7ca"></a>
AlgData&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#ada6c83411d9eb54ddcba58b7db52c7ca">maxActiveAlgData</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:ada6c83411d9eb54ddcba58b7db52c7ca"><td class="mdescLeft">&#160;</td><td class="mdescRight">maximum value of algorithm data of all active vertices over a superstep history <br /></td></tr>
<tr class="separator:ada6c83411d9eb54ddcba58b7db52c7ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adee5333a31d8f0199b059006b0b0a2c3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="adee5333a31d8f0199b059006b0b0a2c3"></a>
AlgData&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#adee5333a31d8f0199b059006b0b0a2c3">minActiveAlgData</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:adee5333a31d8f0199b059006b0b0a2c3"><td class="mdescLeft">&#160;</td><td class="mdescRight">minimum value of algorithm data of all active vertices over a superstep history <br /></td></tr>
<tr class="separator:adee5333a31d8f0199b059006b0b0a2c3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6e2cc4436a685cf860d668266212f42d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6e2cc4436a685cf860d668266212f42d"></a>
AlgData&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a6e2cc4436a685cf860d668266212f42d">sumActiveAlgData</a> [AGGREGATE_HISTORY]</td></tr>
<tr class="memdesc:a6e2cc4436a685cf860d668266212f42d"><td class="mdescLeft">&#160;</td><td class="mdescRight">the sum of the values of algorithm data of all active vertices over a superstep history <br /></td></tr>
<tr class="separator:a6e2cc4436a685cf860d668266212f42d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a634cea0f993b93549a4c8df631a8996a"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a634cea0f993b93549a4c8df631a8996a"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLContainersAggregate.html#a634cea0f993b93549a4c8df631a8996a">isUpdated</a></td></tr>
<tr class="memdesc:a634cea0f993b93549a4c8df631a8996a"><td class="mdescLeft">&#160;</td><td class="mdescRight">update flag <br /></td></tr>
<tr class="separator:a634cea0f993b93549a4c8df631a8996a"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename AlgData&gt;<br />
class TIGLContainersAggregate&lt; AlgData &gt;</h3>

<p>Base class for aggregate information. </p>
<p>It holds important aggregate information and methods for updating it. it could be inherited by another more customized class if needed it is a template class that is parameterized the algorithm data field of the graph algorithm </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a2b7398a983604cf319ecc14b5dc43cee"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename AlgData&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLContainersAggregate.html">TIGLContainersAggregate</a>&lt; AlgData &gt;::incrementExternalMessagesCount </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>currNumMessages</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Increments the number of external Messages after a single node compute in a superstep. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">currNumMessages</td><td>the number of external output messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a04afa8cf6216839d4c877fe28e34ad53"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename AlgData&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLContainersAggregate.html">TIGLContainersAggregate</a>&lt; AlgData &gt;::localAggregateInit </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>ssIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numLocActiveNodes</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Resets the aggregate parameters before the new superstep. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ssIndex</td><td>the superstep index </td></tr>
    <tr><td class="paramname">numLocActiveNodes</td><td>number of local active nodes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aca8c7367d645f65d1d2c7fbc96eb3096"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename AlgData&gt; </div>
<div class="memtemplate">
template&lt;typename VERTEX_ITERATOR &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLContainersAggregate.html">TIGLContainersAggregate</a>&lt; AlgData &gt;::localAggregateUpdate </td>
          <td>(</td>
          <td class="paramtype">VERTEX_ITERATOR&#160;</td>
          <td class="paramname"><em>vertexIt</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>currNumMessages</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Updates the aggregate information after a single node execution during a superstep. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vertexIt</td><td>iterator to the executed vertex </td></tr>
    <tr><td class="paramname">currNumMessages</td><td>the output number of messages after vertex execution </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3ee8a15559012f6b8bb3df99887f4594"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename AlgData&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLContainersAggregate.html">TIGLContainersAggregate</a>&lt; AlgData &gt;::prepareAggregateSysMessage </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classTIGLCommunicationAggregateSysMessage.html">AGG_SYS_MESSAGE_TYPE</a> *&#160;</td>
          <td class="paramname"><em>aggSysInfo</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prepares the aggregate information system message (at the end of the superstep) </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">aggSysInfo</td><td>pointer to the received external message </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af9b0510a2daf3d252622f75cc3a12b10"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename AlgData&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLContainersAggregate.html">TIGLContainersAggregate</a>&lt; AlgData &gt;::setNumLocalActiveNoes </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>numActive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>set the number of local active nodes at the end of a superstep </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">numActive</td><td>the number of local active nodes </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="tiglContainersAggregate_8hpp_source.html">tiglContainersAggregate.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:56 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
